local names = {'Carol', 'Jess', 'John', 'Daniel' }
local ages = {Carol = 20, Jess = 14, John = 41, Daniel = 63}

table.sort(names, function (name1, name2)
  return ages[name1] > ages[name2]  -- ages is an upvalue here, can be seen
end)

for i = 1, #names do
  print(names[i])
end

names = {'Barbara', 'Ben', 'Harry', 'Jen' }
ages = {Barbara = 20, Ben = 14, Harry = 41, Jen = 63}

function sortByAge (names, ages) -- references names and ages are local to sort
  table.sort(names,function (name1, name2) -- names and ages can be seen within sort
    return ages[name1] > ages[name2] -- ages can be seen within anonymous function
  end)
end
sortByAge(names, ages)
print("\n\n\n")
for i = 1, #names do
  print(names[i])
end


names = {'Barbara', 'Ben', 'Harry', 'Jen' }
ages = {Barbara = 20, Ben = 14, Harry = 41, Jen = 63}

function sortByAge () -- call has two parameters neither of which are used
  function ageCompare(name1, name2) -- ages and names are upvalues here
    return ages[name1] > ages[name2] -- ages can be seen within ageCompare
  end
  table.sort(names,ageCompare)  -- references names and ages can be seen within sortByAge
end
sortByAge(names, ages)  -- passed in names and ages in the call but they are not used
print("\n\n\n")
for i = 1, #names do
  print(names[i])
end


