--[[set default values for indices that are used that have no table entries
    by only using one metatable, saves memory.  The function here saves the default
    data in the table itself.  In this case it uses the name "key" as the variable name
    
    Note: to create key it is set up as a table and created using a local variable.  Its
    value is then initialize with the default (which can be of any type) within the
    setDefault function.  This is somewhat obscure and subtle, we end up with an
    index and value pair where the index is an empty table (called key) and the value 
    is the default]]
local key = {}
local metatable = {__index = function(t) return t[key] end}
print("Running code in module")
function setDefault(table, default)
table[key] = default
setmetatable(table, metatable)
end