--[[This is a function which will set a default for a table.
    Note that a new metatable is created for each table.  The function
    creates only one default per table.  Each use of this function creates 
    a closure this can be expensive in terms of memory used (metatable and default) 
    if there are many tables]]
function setDefault(table, default)
local metatable = {__index = function () return default end} -- a new closure, when __index is called, default is known
setmetatable(table, metatable)
end

theTable = {x=10, y=20}
print(theTable.x, theTable.z)

setDefault(theTable, -1)
print (theTable.x, theTable.z)

setDefault(theTable, 0)
print (theTable.x, theTable.z)

