--[[In this code the task is to monitor all accesses to a table.  
    To do this we create a proxy for the table.  This is an empty
    table that has both __index and __newIndex metamethods.  Each
    call is made to the proxy table which checks the calls and then
    passes them onto the real table.]]
    
theTable = {}

local _t = theTable
theTable = {}

local mt = {
__index = function( table, key)
  print("*access to element " .. tostring(key))
  return _t[key]
  end,
  
__newindex = function(table, key, value)
  print("*update of element " .. tostring(key) .. " to " .. tostring(value))
  _t[key] = value
  end
}

setmetatable(theTable, mt)

theTable[2] = "hello"
print(theTable[2])
